// Proteus icq 133575351 lawnmower-man@mail.ru
//    (  )
// :
//      . 
//        (   )
//
#include<stdio.h>
#include<ctype.h>
#include<stack>

#define MAX_PRIORITY 9	//     

std::stack<char>op_stack;	//  
std::stack<int>arg_stack;	//  

//   
int GetPriority(char op)
{
	switch(op) {
	case '(':
	case ')': return 0;
	case '|':
	case '&': return 1;
	case '+':
	case '-': return 2;
	case '*':
	case '/': return 3;
	case '%': return 4;
	}
	return -1;
}

//     
void Eval()
{
	int v2=arg_stack.top(); arg_stack.pop();
	int v1=arg_stack.top(); arg_stack.pop();
	switch(op_stack.top()) {
	case '+': v1+=v2; break;
	case '-': v1-=v2; break;
	case '*': v1*=v2; break;
	case '/': v1/=v2; break;
	case '|': v1|=v2; break;
	case '&': v1&=v2; break;
	case '%': v1%=v2; break;
	}
	op_stack.pop();
	arg_stack.push(v1);
}

//  ()
void ParseValue(int v)
{
	arg_stack.push(v);
}

// 
void ParseOp(char op)
{
	int l1,l2;
	l1=GetPriority(op);
	if(op=='(') l1=MAX_PRIORITY;
	for(;;) {
		if(op_stack.empty()) break;
		if(op_stack.top()=='(') {if(op==')')op_stack.pop();break;}
		l2=GetPriority(op_stack.top());
		if(l1<=l2) Eval(); else break;
	}
	if(op!=')') op_stack.push(op);
}

//   (     )
void Parse(char *expr)
{
	while(*expr) {
		char sym=*expr++; putchar(sym);
		if(isdigit(sym)) ParseValue(sym-'0');
		else ParseOp(sym);
	}
	while(!op_stack.empty()) Eval();
}


int main()
{
	int n=0;
	char *expr="1+1+(((1*2+3*4)))/2";
	Parse(expr);
	printf("=%d\n",arg_stack.top());
	getchar();
	return 0;
}
